<template>
    <div>
        <label :for="fieldname">{{ label }}</label>
        <br>
        <select v-model="newValue" :id="fieldname" v-on:change="changeValueIfNotTheSame" :disabled="disabled">
            <option v-if="nullable" :value="null"></option>
            <option v-for="item in items" :value="item[itemValue]">{{ item[itemText] }}</option>
        </select>
        <broject-database-fieldchanger
            :model="model"
            :model-id="modelId"
            :fieldname="fieldname"
            :old-value="oldValue"
            :new-value="newValue"
            :disabled="disabled"
            :changing="changing"
            @changed="onValueChanged"
        ></broject-database-fieldchanger>
    </div>
</template>

<script>
    import DatabaseFieldChanger from '../DatabaseFieldChanger.vue';

    export default {

        components: {
            'broject-database-fieldchanger': DatabaseFieldChanger,
        },

        props: {
            model: {
                type: String,
                required: true,
            },

            modelId: {
                type: Number,
                required: true,
            },

            fieldname: {
                type: String,
                required: true,
            },

            items: {
                type: Array,
                default: function () {
                    return [];
                }
            },

            itemValue: {
                type: String,
                default: null,
            },

            itemText: {
                type: String,
                default: null,
            },

            value: {
                default: null,
            },

            disabled: {
                type: Boolean,
                default: false,
            },

            nullable: {
                type: Boolean,
                default: false,
            },

            label: {
                type: String,
                default: null,
            },
        },

        data() {
            return {
                changing: false,
                oldValue: this.value,
                newValue: this.value,
            }
        },

        methods: {
            changeValueIfNotTheSame() {
                if (this.oldValue !== this.newValue) {
                    this.changing = true;
                    this.$emit('changeInProgress');
                }
            },

            onValueChanged(result) {
                this.$emit('successfullyChanged');
                this.changing = false;
                this.oldValue = result.newValue;
                this.newValue = result.newValue;
            }
        }

    }
</script>
